# -*- coding: utf-8 -*-
'''
Created on 13 дек. 2018 г.

@author: dvd
'''
from __future__ import unicode_literals

import pexpect
import logging

logger = logging.getLogger(__name__)
def root_pam_auth(password):
        '''Аутентификация суперпользователя (root) через PAM'''
        # Убираем возможные переносы каретки в пароле для подстраховки
        password = password.replace('\n','')
        password = password.replace('\r','')
        try:
            child = pexpect.spawn('/bin/su', ['-', 'root'], env={'LC_ALL':'en_US.UTF-8'})
            child.expect('Password:')
            child.sendline(password)
            result=child.expect(['su: Authentication failure', 'root'])
            child.close()
        except Exception as err:
            child.close()
            logger.error("root_pam_auth Error authenticating. Reason: %s",err)
            return False
        if result == 0:
            logger.info("root_pam_auth Authentication failed for super user")
            return False
        else:
            logger.info("root_pam_auth Authentication succeeded for super user")
            return True