# -*- coding: utf-8 -*-
'''
Created on 23 окт. 2018 г.

@author: dvd
'''
from __future__ import unicode_literals

from django import forms


class LicenseUpload(forms.Form):
    
    
    license_file = forms.FileField(
        required=True
    )
    
    def __init__(self, *args, **kwargs):
        super(LicenseUpload, self).__init__(*args, **kwargs)
        
        for _, field in self.fields.items():
            if field.required:
                field.widget.attrs['required']=''
    
    def clean_files(self):
        license_file = self.cleaned_data.get('license_file');
        
        if license_file is not None:
            if license_file.size > 1024*1024:
                raise forms.ValidationError("Размер файла превышает допустимый")
            
        return license_file