# -*- coding: utf-8 -*-
'''
Created on 4 окт. 2018 г.

@author: dvd
'''
from __future__ import unicode_literals

from uds.REST import Handler
from uds.models.Log import Log

import logging

logger = logging.getLogger(__name__)

class Monitoring(Handler):
    needs_admin = True  # By default, staff is lower level needed

    def get(self):
        
        logs = Log.objects.all().order_by('-created')[0:1000]
        
        res = [
            {
                'date': x.created,
                'level': x.level, 
                'source': x.source, 
                'message': x.data
            } for x in logs
        ]

        return res
